#include <iostream.h>
//using namespace std;

struct elemento
  {  int valor;     // Valor del elemento
     elemento *nxt; // Siguiente elemento
  };

class Conjunto{
	elemento *inicial;
	elemento *actual;
	elemento *final;
public:
	Conjunto(); // Constructor de la clase
	int add(int); // Añade un nuevo elemento. Devuelve 0 si ya existía.
	int remove(int); // Elimina el elemento indicado. Devuelve 0 si no existía.
	void inicio(); // Prepara el conjunto para comenzar a recorrer sus elementos
	int haySiguiente(); // Devuelve 1 si hay elemento siguiente y 0 si no 
	int siguiente(); // Devuelve el valor del siguiente elemento y pasa a ese elemento
	int pertenece(int); // Devuelve 1 si el elemento está en el conjunto y 0 si no
};

Conjunto::Conjunto(){
  inicial=NULL;
}

void Conjunto::inicio(){
  actual=NULL;          // No apuntamos a ningún elemento
}

int Conjunto::haySiguiente(){
  if(actual==NULL && inicial==NULL){     // Si no hay elementos
    return 0;
  }
  if(actual!=NULL && actual->nxt==NULL){  // Si estamos apuntando a un elemento, miramos si hay siguiente
    return 0;
  }
  return 1; // En los demás casos (actual==NULL y inicial!=NULL o actual != NULL y actual.nxt!=NULL) hay siguiente
}

int Conjunto::siguiente(){
  if(inicial!=NULL && actual==NULL){     // Si no hemos comenzado a recorrer el conjunto
    actual=inicial;
    return actual->valor;
  }
  if(actual!=NULL && actual->nxt!=NULL){  // Si estamos apuntando a un elemento, pasamos al siguiente
    actual=actual->nxt;
    return actual->valor;
  }
  return -1; // Si se solicita el siguiente si comprobar, devuelve cualquier cosa
}

int Conjunto::pertenece(int valor){
  elemento* temp; // Para guardar actual
  temp=actual;
  this->inicio();
  while(this->haySiguiente()){
    if(this->siguiente()==valor){
      actual=temp;
      return 1;
    }
  }
  actual=temp;  
  return 0;
}

int Conjunto::add(int valor){
  elemento* temp;
  if(this->pertenece(valor)){
    return 0; // Ya pertenecía, no se añade
  }else{  // Aquí va lo de comprobar si pertenece antes de añadirlo al final
    temp = new elemento; // Reservamos espacio para el nuevo elemento
    temp->valor=valor;
    temp->nxt=NULL;
    if(inicial==NULL){
      inicial=temp;
      final=temp;
    } else {
      final->nxt=temp;
      final=temp;
    }
    return 1; // No hay errores
  }
}

int Conjunto::remove(int valor){
  elemento *temp, *prev; // Para guardar actual y el justo anterior
  temp=actual;
  this->inicio();
  while(this->haySiguiente()){
    prev=actual; // guardamos el anterior
    if(this->siguiente()==valor){ // si hemos encontrado el elemento
      if(prev==NULL){ // Si es el primer elemento
        inicial=actual->nxt;
      }else{
        prev->nxt=actual->nxt; // Enlazamos el anterior con el siguiente
        if(actual->nxt==NULL){ // Si era el último
          final=prev; 
        }
      }
      delete actual; 
      return 1; // No hay errores
    }
  }
  actual=temp;  
  return 0; //
}


/*int main(){
     int option;
     Conjunto A;  // Definimos A como conjunto de enteros
     A.add(3); // Añadimos el 3, el 5 y el 7
     A.add(5);
     A.add(5); // No se añade, porque ya pertenecía
     A.add(7);
     A.inicio(); // Comenzamos a recorrer el conjunto 
     cout << "Elemento 1: " << A.siguiente() << endl; // Primer elemento
     cout << A.pertenece(5) << endl;  // 5 pertenece al conjunto
     cout << "Elemento 2: " << A.siguiente() << endl; // Segundo elemento
     cout << A.pertenece(6) << endl;  // 6 no pertenece al conjunto
     cout << "Elemento 3: " << A.siguiente() << endl; // Tercer elemento
     A.remove(7); // Eliminamos el 7
     A.add(9);  // Añadimos el 9
     A.inicio(); // Lo recorremos otra vez
     while(A.haySiguiente()){
       cout << A.siguiente() << endl;
     }
 }*/
 
 
