#include <iostream.h>
//using namespace std;

struct par
  {  int a,b;     // Definimos el par (a,b)
     par *nxt; // Siguiente par
  };  

class Relacion{
	par *inicial;
	par *actual;
	par *final;
	void inicio();
	int haySiguiente();
	int siguiente();
public:
	Relacion(); // Constructor de la clase
	int add(int a,int b); // Aade un nuevo par. Devuelve 0 si ya existia.
	int remove(int a,int b); // Elimina el par indicado. Devuelve 0 si no existia.
	int estanRelacionados(int a,int b); // Devuelve 1 si aRb y 0 si no
};

Relacion::Relacion(){
  inicial=NULL;
}

void Relacion::inicio(){
  actual=NULL;          // No apuntamos a ningún par
}

int Relacion::haySiguiente(){
  if(actual==NULL && inicial==NULL){     // Si no hay pars
    return 0;
  }
  if(actual!=NULL && actual->nxt==NULL){  // Si estamos apuntando a un par, miramos si hay siguiente
    return 0;
  }
  return 1; // En los demás casos (actual==NULL y inicial!=NULL o actual != NULL y actual.nxt!=NULL) hay siguiente
}

int Relacion::siguiente(){
  if(inicial!=NULL && actual==NULL){     // Si no hemos comenzado a recorrer el Relacion
    actual=inicial;
    return 0;
  }
  if(actual!=NULL && actual->nxt!=NULL){  // Si estamos apuntando a un par, pasamos al siguiente
    actual=actual->nxt;
    return 0;
  }
  return -1; // Si se solicita el siguiente si comprobar, devuelve cualquier cosa
}

int Relacion::estanRelacionados(int a,int b){
  par* temp; // Para guardar actual
  temp=actual;
  this->inicio();
  while(this->haySiguiente()){
    this->siguiente();
    if(actual->a==a && actual->b==b){
      actual=temp;
      return 1;
    }
  }
  actual=temp;  
  return 0;
}

int Relacion::add(int a, int b){
  par* temp;
  if(this->estanRelacionados(a,b)){
    return 0; // Ya pertenecía, no se añade
  }else{  // Aquí va lo de comprobar si pertenece antes de añadirlo al final
    temp = new par; // Reservamos espacio para el nuevo par
    temp->a=a;
    temp->b=b;
    temp->nxt=NULL;
    if(inicial==NULL){
      inicial=temp;
      final=temp;
    } else {
      final->nxt=temp;
      final=temp;
    }
    return 1; // No hay errores
  }
}

int Relacion::remove(int a,int b){
  par *temp, *prev; // Para guardar actual y el justo anterior
  temp=actual;
  this->inicio();
  while(this->haySiguiente()){
    prev=actual; // guardamos el anterior
    this->siguiente();
    if(actual->a==a && actual->b==b){ // si hemos encontrado el par
      if(prev==NULL){ // Si es el primer par
        inicial=actual->nxt;
      }else{
        prev->nxt=actual->nxt; // Enlazamos el anterior con el siguiente
        if(actual->nxt==NULL){ // Si era el último
          final=prev; 
        }
      }
      delete actual; 
      return 1; // No hay errores
    }
  }
  actual=temp;  
  return 0; //
}
